Loading...
Searching...
No Matches
std_wrapper.h File Reference
`#include "polys/simpleideals.h"`
`#include "kernel/structs.h"`

Go to the source code of this file.

## Functions

ideal | gfanlib_kStd_wrapper (ideal I, ring r, tHomog h=testHomog)
ideal | gfanlib_satStd_wrapper (ideal I, ring r, tHomog h=testHomog)
ideal | gfanlib_monomialabortStd_wrapper (ideal I, ring r, tHomog h=testHomog)

## Function Documentation

## gfanlib_kStd_wrapper()

ideal gfanlib_kStd_wrapper | ( | ideal | I,
|  | ring | r,
|  | tHomog | h = testHomog )

Definition at line 6 of file std_wrapper.cc.

{
ring origin = currRing;
if (origin != r)
rChangeCurrRing(r);
intvec* nullVector = NULL;
ideal stdI = kStd2(I,currRing->qideal,h,&nullVector,(bigintmat*)NULL); // there is still a memory leak here!!!
id_DelDiv(stdI,currRing);
idSkipZeroes(stdI);
if (nullVector!=NULL) delete nullVector;
if (origin != r)
rChangeCurrRing(origin);
return stdI;
}
bigintmat
Matrices of numbers.
Definition bigintmat.h:51
intvec
Definition intvec.h:24
h
STATIC_VAR Poly * h
Definition janet.cc:971
kStd2
ideal kStd2(ideal F, ideal Q, tHomog h, intvec **w, bigintmat *hilb, int syzComp, int newIdeal, intvec *vw, s_poly_proc_t sp)
generic interface to GB/SB computations, large hilbert vectors
Definition kstd1.cc:2607
NULL
#define NULL
Definition omList.c:12
rChangeCurrRing
void rChangeCurrRing(ring r)
Definition polys.cc:16
currRing
VAR ring currRing
Widely used global variable which specifies the current polynomial ring for Singular interpreter and ...
Definition polys.cc:13
id_DelDiv
void id_DelDiv(ideal id, const ring r)
delete id[j], if LT(j) == coeff*mon*LT(i) and vice versa, i.e., delete id[i], if LT(i) == coeff*mon*L...
Definition simpleideals.cc:463
idSkipZeroes
void idSkipZeroes(ideal ide)
gives an ideal/module the minimal possible size
Definition simpleideals.cc:201

## gfanlib_monomialabortStd_wrapper()

ideal gfanlib_monomialabortStd_wrapper | ( | ideal | I,
|  | ring | r,
|  | tHomog | h = testHomog )

Definition at line 172 of file std_wrapper.cc.

{
ring origin = currRing;
if (origin != r)
rChangeCurrRing(r);
ideal stdI = kStd2(I,currRing->qideal,h,NULL,(bigintmat*)NULL,0,0,NULL,abort_if_monomial_sp);
id_DelDiv(stdI,currRing);
idSkipZeroes(stdI);
if (origin != r)
rChangeCurrRing(origin);
return stdI;
}
abort_if_monomial_sp
static BOOLEAN abort_if_monomial_sp(kStrategy strat)
Definition customstd.cc:92

## gfanlib_satStd_wrapper()

ideal gfanlib_satStd_wrapper | ( | ideal | I,
|  | ring | r,
|  | tHomog | h = testHomog )

Definition at line 124 of file std_wrapper.cc.

{
ring origin = currRing;
if (origin != r)
rChangeCurrRing(r);
int n = rVar(currRing);
gitfan_satstdSaturatingVariables = std::vector<int>(n);
for (int i=n-1; i>=0; i--)
gitfan_satstdSaturatingVariables[i] = i+1;
ideal stdI = kStd2(I,currRing->qideal,h,NULL,(bigintmat*)NULL,0,0,NULL,sat_vars_sp);
id_DelDiv(stdI,currRing);
idSkipZeroes(stdI);
if (origin != r)
rChangeCurrRing(origin);
return stdI;
}
i
int i
Definition cfEzgcd.cc:132
rVar
static short rVar(const ring r)
define rVar(r) (r->N)
Definition ring.h:598
gitfan_satstdSaturatingVariables
std::vector< int > gitfan_satstdSaturatingVariables
Definition std_wrapper.cc:5
sat_vars_sp
static BOOLEAN sat_vars_sp(kStrategy strat)
Definition std_wrapper.cc:27